/*
 * Manual context switch.  The first thing we do is save the registers so we
 * can use a naked attribute.
 */
/*
void vPortYield( void );// __attribute__ ( ( naked ) );
void vPortYield( void )
{
	portSAVE_CONTEXT();
	vTaskSwitchContext();
	portRESTORE_CONTEXT();

	//asm volatile ( "ret" );
}
*/
// FIXME: Очень кривой файл =(

.alias SP 39	; stack pointer
.alias BP 38	; function frame base pointer
.alias SI 37	; source address
.alias DI 36	; destination address
.alias CX 35	; counter


.global vPortYield

.data
SysT.result:
	.long 0

.text

// vPortYield START
// Обработку будем делать от глобального стека.
vPortYield:
	
	jmp vPortYield_steck
	setl #MSKR, 0		// отключаем прерывания на момент смены контекста.// FIXME: Тут нужно по маске!!
	
complete


vPortYield_steck:

	jmp vPortYield_hendler2

	saveSP := getl #SP
	saveBP := getl #BP
	loadSP := rdl gSP
	loadBP := rdl gBP
	reta := rdl @saveSP

	wrl @saveSP, iSP
	wrl @saveBP, iBP

	setl #SP, @loadSP
	setl #BP, @loadBP
	wrl @reta, master.isr.retaddr

complete


vPortYield_hendler2:

	jmp portSAVE_CONTEXT

	getl vPortYieldNext1
	getl #SP
	subl  @1, sizeof.ptr	// Опустили SP
	wrl @3,@1		// Записали туда адрес следующего параграфа
	setl  #SP, @2		// Установили указатель на него.


complete

vPortYieldNext1:

	jmp vTaskSwitchContext
	getl vPortYieldNext2
	wrl @1,#SP

complete

vPortYieldNext2:

	jmp portRESTORE_CONTEXT
	getl vPortYield.stop
	wrl @1,#SP

complete

vPortYield.stop:

	jmp vPortYield.PF

	getl #SP
	addl  @1, sizeof.ptr	// вернули SP
	setl  #SP, @1		// Установили указатель на него.

complete


// Заменяем #SP, #BP на значения задачи.
vPortYield.PF:

	jmp vPortYield.final


	saveSP := getl #SP
	saveBP := getl #BP
	loadSP := rdl iSP
	loadBP := rdl iBP

	wrl @saveSP, gSP
	wrl @saveBP, gBP
	setl #SP, @loadSP
	setl #BP, @loadBP
	

complete

// FIXME: Устанавливаем таймер. и уходим на задачу.
vPortYield.final:

	rdl master.isr.retaddr
	jmp @1

	getl 0
	getl 0x0000FFF
	getl 0x0000001

	getl 0x00000001	// бит 0 STCR - разрешение работы счётчика
	slll @4, 1		// бит 1 STCR - признак циклической работы таймера
	slll @3, 8		// биты 8 - 15 STCR - prediv
	setl #STVALR, @5

	or @4, @3
	or @1, @3
	getl 0x00000000
	getl #MSKR

	or @1, 0x00000002
	wrl @3, SysT.result
	setl #STCR, @5
    	setl #MSKR, 0xffffffff

complete

// vPortYield END

